import * as trpc from "@trpc/server";
import { DendriformPatch } from "dendriform-immer-patch-optimiser";
import { Runtime } from "..";
import { EventDelegate } from "../events";
import { Issue } from "../runtime/handler/definition";
export declare type State = {
    app: string;
    stage: string;
    functions: Record<string, FunctionState>;
    live: boolean;
    stacks: {
        status: any;
    };
};
export declare type FunctionState = {
    state: "idle" | "building" | "checking";
    invocations: Invocation[];
    issues: Record<string, Issue[]>;
    warm: boolean;
};
export declare type Invocation = {
    id: string;
    request: any;
    response?: Runtime.Response;
    times: {
        start: number;
        end?: number;
    };
    logs: {
        message: string;
        timestamp: number;
    }[];
};
export declare type Context = {
    region: string;
    state: State;
    onStateChange: EventDelegate<DendriformPatch[]>;
    onDeploy: EventDelegate<void>;
};
export declare const router: import("@trpc/server/dist/declarations/src/router").Router<Context, Context, Record<"getCredentials", import("@trpc/server/dist/declarations/src/internals/procedure").Procedure<Context, Context, undefined, undefined, {
    region: string;
    credentials: {
        accessKeyId: string;
        secretAccessKey: string;
        sessionToken: string | undefined;
    };
}>> & Record<"getState", import("@trpc/server/dist/declarations/src/internals/procedure").Procedure<Context, Context, undefined, undefined, State>>, Record<"deploy", import("@trpc/server/dist/declarations/src/internals/procedure").Procedure<Context, Context, undefined, undefined, void>>, Record<"onStateChange", import("@trpc/server/dist/declarations/src/internals/procedure").Procedure<Context, Context, undefined, undefined, trpc.Subscription<DendriformPatch[]>>>, trpc.DefaultErrorShape>;
export declare type Router = typeof router;
